require 'savon'
require 'active_support/core_ext'

User = 'INSERT HERE USER PROVIDED BY JUNIPER XML AGENTS'
Password = 'INSERT HERE PASS PROVIDED BY JUNIPER XML AGENTS'

AuxStartDate = Date.today + rand(4..6).months
AuxEndDate = AuxStartDate + rand(1..7).days

StartDate = AuxStartDate.strftime("%F")
EndDate = AuxEndDate.strftime("%F")

flightAvailclient = Savon.client(
    wsdl: 'https://xml-uat.bookingengine.es/webservice/jp/webservicejp.asmx?wsdl', 
    endpoint: 'https://xml-uat.bookingengine.es/webservice/jp/operations/availtransactions.asmx',
    ssl_verify_mode: :none,
    log_level: :debug, 
    log: true, 
    pretty_print_xml: true,
    convert_request_keys_to: :none,
    headers: {
        "Content-Type" => "text/xml;charset=UTF-8",
        "SOAPAction" => '"http://www.juniper.es/webservice/2007/FlightAvail"'
    }
)


OriginIATA = 'MAD'
DestinationIATA = 'BCN'

AdvancedOptions = {
    'ShowBreakdownPrice'=> "false"
}

FlightAvailRQ = {  
    Login: '',:attributes! => {Login: {"Password" => Password, "Email" => User}},
    Paxes: {Pax: {Age:"25"},:attributes! => { Pax: {"IdPax" => "1"}}},
    FlightRequest: {
        SearchSegmentsFlight:{
            SearchSegmentFlight: {
                Routes: {
                    :Route => ["",""], 
                    :attributes! => { :Route => { :Date => [StartDate, EndDate], :OriginIATA => [OriginIATA,DestinationIATA], :DestinationIATA => [DestinationIATA,OriginIATA] }}
                },
            CountryOfResidence: "ES"}
        },
        RelPaxesDist: {
            RelPaxDist: {
                RelPaxes: {
                    RelPax:'',:attributes! => { RelPax: {"IdPax" => "1"}}
                }
            }
        }
    },
    AdvancedOptions: AdvancedOptions
}

flightAvailclient.call(:flight_avail, message: {
    FlightAvailRQ: FlightAvailRQ, 
    :attributes! => {
        FlightAvailRQ: {
            "Version" => "1.1",
            "Language" => "EN"
        }
    }
})